
Texture2D tex;

float4x4 tVP : VIEWPROJECTION;
float4x4 tW : WORLD;
float Str = 1;

SamplerState g_samLinear : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

 
struct vsIn
{
	float4 PosO : POSITION;
	float4 TexCd : TEXCOORD0;
	float4 NormO : NORMAL;
};

struct vs2ps
{
    float4 PosWVP: SV_POSITION;
	float4 col : COLOR;
	float4 NormWVP : NORMAL;
	float2 dir : TEXCOORD;
	float2 dir1 : TEXCOORD1;
};

struct psIn
{
    float4 PosWVP: SV_POSITION;
	float4 col : COLOR;
};

vs2ps VS(vsIn input)
{
    vs2ps Out = (vs2ps)0;
    Out.PosWVP  = mul(input.PosO,mul(tW,tVP));
	Out.NormWVP = mul(input.NormO,mul(tW,tVP));
	Out.col = tex.SampleLevel(g_samLinear,input.TexCd.xy,0);
	return Out;
} 

[maxvertexcount(2)]
void GS(point vs2ps input[1], inout LineStream<psIn> lines)
{
    psIn output;
	
	output.PosWVP = input[0].PosWVP;
	output.col = input[0].col;
	lines.Append(output);
	output.PosWVP = input[0].PosWVP + (input[0].NormWVP * Str);
	lines.Append(output);
}


float4 PS_Tex(psIn In): SV_Target
{
    return  In.col;
}

technique10 Constant
{
	pass P0
	{
		SetHullShader( 0 );
		SetDomainShader( 0 );
		SetGeometryShader( CompileShader( gs_5_0, GS() ) );
		SetVertexShader( CompileShader( vs_5_0, VS() ) );
		SetPixelShader( CompileShader( ps_5_0, PS_Tex() ) );
	}
}




